# Spine Bootstrap

The spine bootstrap set a standard for your project

## Usage

### Create your hook
```
# myHook.ts
import {
  bootstrapHook,
  initHook,
  deathHook,
} from '@spine/bootstrap';

bootstrapHook.addAction('MyHook', () => {
  console.log('registered');
  initHook.addAction('MyHook', () => {
    console.log('initialize');
    deathHook.addAction('MyHook', () => {
      console.log('destroy');
    });
  });
});
```

### Bootstrap your project
```
# index.ts
import { bootstrap } from '@spine/bootstrap/server';
import './myHook';

bootstrap()
  .catch(error => console.log(error.stack || error.message));
```
