"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkDied = checkDied;
exports.checkBootstrap = checkBootstrap;
exports.bootstrap = bootstrap;
exports.die = die;
exports.dieSync = dieSync;
Object.defineProperty(exports, "bootstrapHook", {
  enumerable: true,
  get: function get() {
    return _bootstrap2.default;
  }
});
Object.defineProperty(exports, "BootstrapParams", {
  enumerable: true,
  get: function get() {
    return _bootstrap2.Params;
  }
});
Object.defineProperty(exports, "initHook", {
  enumerable: true,
  get: function get() {
    return _init.default;
  }
});
Object.defineProperty(exports, "InitParams", {
  enumerable: true,
  get: function get() {
    return _init.Params;
  }
});
Object.defineProperty(exports, "deathHook", {
  enumerable: true,
  get: function get() {
    return _death.default;
  }
});
Object.defineProperty(exports, "DeathParams", {
  enumerable: true,
  get: function get() {
    return _death.Params;
  }
});
exports.log = void 0;

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.promise");

require("regenerator-runtime/runtime");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _logger = require("@spine/logger");

var _bootstrap2 = _interopRequireWildcard(require("./hooks/bootstrap"));

var _init = _interopRequireWildcard(require("./hooks/init"));

var _death = _interopRequireWildcard(require("./hooks/death"));

var log = (0, _logger.logger)('bootstrap');
exports.log = log;
var died = false;

function checkDied() {
  return died;
}

var destroy = function destroy(async) {
  if (died) {
    throw new Error('Dying has already started');
  }

  died = true;
  log.verbose('Shutting down...');
  return _death.default.do({
    async: async
  });
};

var started = false;

function checkBootstrap() {
  return started;
}

function bootstrap() {
  return _bootstrap.apply(this, arguments);
}

function _bootstrap() {
  _bootstrap = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    var bootstrap, init;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!started) {
              _context.next = 2;
              break;
            }

            throw new Error('Bootstrap has already started');

          case 2:
            started = true;
            log.verbose('Registering hooks...');
            _context.next = 6;
            return _bootstrap2.default.do({});

          case 6:
            bootstrap = _context.sent;
            log.verbose('Initializing...');
            _context.next = 10;
            return _init.default.do({});

          case 10:
            init = _context.sent;
            return _context.abrupt("return", {
              bootstrap: bootstrap,
              init: init
            });

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _bootstrap.apply(this, arguments);
}

function die() {
  return _die.apply(this, arguments);
}

function _die() {
  _die = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var result, keys, values, key;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            result = destroy(true);
            keys = [];
            values = [];

            for (key in result) {
              keys.push(key);
              values.push(Promise.resolve(result[key]));
            }

            _context2.next = 6;
            return Promise.all(values).then(function (resolved) {
              var obj = {};
              resolved.forEach(function (value, index) {
                obj[keys[index]] = value;
              });
              return obj;
            });

          case 6:
            return _context2.abrupt("return", _context2.sent);

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _die.apply(this, arguments);
}

function dieSync() {
  return destroy(false);
}
//# sourceMappingURL=index.js.map